//+------------------------------------------------------------------+
//|                                                    Jake Take.mq4 |
//|                                                         Aaragorn |
//|                   http://www.forex-tsd.com/members/aaragorn.html |
//+------------------------------------------------------------------+
#property copyright "Aaragorn"
#property link      "http://www.forex-tsd.com/members/aaragorn.html"

//------------* System specific *----------//
string              SystemName = "Jake Take";
double                 version = 1;
extern int         MagicNumber =  6253492; // Magic Number -- change for every pair traded

//------------------INCLUDES---------------//
#include <stdlib.mqh>

//------------------GLOBALS----------------//
extern double        TakeProfit = 20;
extern double          StopLoss = 25;
extern int       DetectionLevel = 6;
extern double         SellLevel = 66.3860;
extern double          BuyLevel = 33.1723;
extern double       MaximumRisk = 1;
//extern double HH_LLAvePeriodEnt = 48;
//extern double HH_LLAvePeriodExi = 24;
//extern int             BarShift = 1;
//extern double    TrailATRPeriod = 3;
extern int         MaxOpenTrade = 1;
extern bool        Usefilewrite = false;//saves data to file
extern bool           UseAlerts = false;//allows alerts to be displayed

//---------internal variables--------------//
int handle=0,ticket=0,cnt,PreviousOpenOrders=0;
double TP=0,SL=0,lot=0,Lots=0,Slippage=0,Spread=0;
string Ordercomment=" ";
bool BuyIsOpen = false;
bool SellIsOpen = false;
bool OrderAllowed = false;
bool DoubleDown=false;
int DoubleDownCounter=0;
int DoubleDownCounterLong=0;
int DoubleDownCounterShort=0;

// Bar handling
datetime bartime=0;                   // used to determine when a bar has moved
int      bartick=0;                   // number of times bars have moved
int      objtick=0;                   // used to draw objects on the chart
int      tickcount=0;


//+-------------+
//| Custom init |
//|-------------+
// Called ONCE when EA is added to chart or recompiled

int init()
  {
   int    i;
   string o;
   
   //remove the old objects 
   for(i=0; i<Bars; i++) 
     {
      o=DoubleToStr(i,0);
      ObjectDelete("myx"+o);
      ObjectDelete("myz"+o);
     }
   objtick=0;

   Print("Init happened ",CurTime());
   Comment(" ");
  }

//+----------------+
//| Custom DE-init |
//+----------------+
// Called ONCE when EA is removed from chart

int deinit()
  {
   int    i;
   string o;
   //remove the old objects 
   
   for(i=0; i<Bars; i++) 
     {
      o=DoubleToStr(i,0);
      ObjectDelete("myx"+o);
      ObjectDelete("myz"+o);
     }
   objtick=0;
      
   Print("DE-Init happened ",CurTime());
   Comment(" ");
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
     // bar counting
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      bartick++; 
      objtick++;
      //TradeAllowed=true;
     }
  
  double HHenter=0,LLenter=0,HHexit=0,LLexit=0,RSI=0,RSI1=0;
 // HHenter = High[Highest(NULL,0,MODE_HIGH,HH_LLAvePeriodEnt,BarShift)];    
  //LLenter = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriodEnt,BarShift)];
  
  //HHexit = High[Highest(NULL,0,MODE_HIGH,HH_LLAvePeriodExi,BarShift)];    
  //LLexit = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriodExi,BarShift)];
  
  RSI=iRSI(NULL,0,14,PRICE_CLOSE,0);
  RSI1=iRSI(NULL,0,14,PRICE_CLOSE,2);

//-----------------Order Management Signals--------------------------+
   doubledown();
   
  /* double osl=0; 
    if(OrdersTotal()>0)
      {
      for(int i=0;i<OrdersTotal();i++)
         {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
            {
            if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
               {
               if(OrderType()==OP_SELL)
                  {
                  osl=OrderStopLoss();
                     ObjectDelete("DDL");
                     ObjectCreate("DDL", OBJ_TEXT, 0, Time[0], Low[0]-(40*Point));
                     ObjectSetText("DDL","Short DDL: "+DoubleToStr(osl-(DetectionLevel*Point),4),8,"Arial",White);
                     ObjectDelete("Ask");
                     ObjectCreate("Ask", OBJ_TEXT, 0, Time[0], Low[0]-(20*Point));
                     ObjectSetText("Ask","Ask: "+DoubleToStr((Ask),4),8,"Arial",White);   
                  }
                if(OrderType()==OP_BUY)
                  {
                  osl=OrderStopLoss();
                     ObjectDelete("DDL");
                     ObjectCreate("DDL", OBJ_TEXT, 0, Time[0], High[0]+(40*Point));
                     ObjectSetText("DDL","Long DDL: "+DoubleToStr(osl+(DetectionLevel*Point),4),8,"Arial",White);
                     ObjectDelete("Bid");
                     ObjectCreate("Bid", OBJ_TEXT, 0, Time[0], High[0]+(20*Point));
                     ObjectSetText("Bid","Bid: "+DoubleToStr((Bid),4),8,"Arial",White);   
                  }   
               }
            }//select   
          }//for     
       }//orderstotal*/

   //OrderAllowed = false;
  // TrailingStop();
   //IsOrderAllowed();
   if(/*RSI1<BuyLevel &&*/ RSI<=BuyLevel /*&& OrderAllowed == true*/)
      {
      Print("BUY SIGNAL----->RSI: ",RSI," >=  66.3860 RSI Entry Level");
      OpenBuy();
      }  
 /*  if(BuyIsOpen == true && Bid < LLexit)
      {
      Print("CLOSE BUY SIGNAL----->Bid ",Bid,"  <  ",LLexit," LLexit");
      EXIT();
      }*/
      //IsOrderAllowed();
     // Print("When Bid ",Bid," < ",LLenter," && (True=1 False=0) OrderAllowed: ",OrderAllowed);
   if(/*RSI1>SellLevel &&*/ RSI>=SellLevel /*&& OrderAllowed == true*/)
      {
      Print("SELL SIGNAL----->RSI: ",RSI," <=  33.1723 RSI Entry Level");
      OpenSell();
      } 
 /*  if(SellIsOpen == true && Ask > HHexit)
      {
      Print("CLOSE SELL SIGNAL----->Ask ",Ask,"  >  ",HHexit," HHexit");
      EXIT();
      } */
         
 //----
return(0);
}//close of start ini loop  
//+----------------------------Is Order Allowed-----------------------------------+
void IsOrderAllowed()
{
   if(DoubleDownCounter==0)
      {
      OrderAllowed=true;
      return(0);
      }
      
   if(DoubleDownCounter>2)
      {
    /*  for(int i=0;i<OrdersTotal();i++)
         {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
            {
            if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
               {
                  if(OrderType()==OP_BUY)
                     {
                     if(OrderComment()>=DoubleToStr(3,4))
                        {*/
                        //Print("BLOCKED SIGNAL --->OpenOrderComment ",OrderComment()," == Ordercomment ",Ordercomment);
                        OrderAllowed=false;
                        //DoubleDownCounterLong=0;
                        DoubleDownCounter=0;
                        }
                        else
                        {
                        Print("ALLOWED SIGNAL --->OpenOrderComment ",OrderComment()," != Ordercomment ",Ordercomment);
                        OrderAllowed=true;
                        }
                     return(0);
               /*      }//if buy
                  if(OrderType()==OP_SELL)
                     {
                     if(OrderComment()>=DoubleToStr(3,4))
                        {
                        //Print("BLOCKED SIGNAL --->OpenOrderComment ",OrderComment()," == Ordercomment ",Ordercomment);
                        OrderAllowed=false;
                        DoubleDownCounterShort=0;
                        }
                        else
                        {
                        Print("ALLOWED SIGNAL --->OpenOrderComment ",OrderComment()," != Ordercomment ",Ordercomment);
                        OrderAllowed=true;
                        }
                     return(0);
                     }//if sell 
             }//if symbol  
           }//if select     
         } //for loop   
      return(0);
      }//if orders>0   
return(0);*/
}

//+----------------------------trailing stop--------------------------------------+
void TrailingStop()
{
  //double ATR = 0;
  //ATR = High[Highest(iATR(Symbol(),0,TrailATRPeriod ,0))];
  double HHexit=0,LLexit=0;
  //HHexit = High[Highest(NULL,0,MODE_HIGH,HH_LLAvePeriodExi,BarShift)];    
  //LLexit = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriodExi,BarShift)];
  
   for(int i=0;i<OrdersTotal();i++)
   {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
       {
          if( (OrderType() == OP_BUY) && LLexit > OrderStopLoss() )
           {
            OrderModify(OrderTicket(),OrderOpenPrice(),LLexit,OrderTakeProfit(),0,GreenYellow);
            return(0);

           }//if buy & modify condition
           
          if( (OrderType() == OP_SELL) && HHexit < OrderStopLoss() )
           {
             OrderModify(OrderTicket(),OrderOpenPrice(),HHexit,OrderTakeProfit(),0,Red);
             return(0);              
           }//if sell & modify condition
           
       }//if symbol  
     }//if select     
   } //FOR LOOP   
   return(0);
}// trailing stop 

//+---------------------Lots Size----------------------------------------+  
double LotSize()
{
    double     lot_min        = MarketInfo( Symbol(), MODE_MINLOT  );
    double     lot_max        = MarketInfo( Symbol(), MODE_MAXLOT  );
    double     lot_step       = MarketInfo( Symbol(), MODE_LOTSTEP );
    double     freemargin     = AccountFreeMargin();
    int        leverage       = AccountLeverage();
    double        lotsize        = MarketInfo( Symbol(), MODE_LOTSIZE );
 
    if( lot_min < 0 || lot_max <= 0.0 || lot_step <= 0.0 || lotsize <= 0 ) 
    {
        Print( "LotSize: invalid MarketInfo() results [", lot_min, ",", lot_max, ",", lot_step, ",", lotsize, "]" );
        return(-1);
    }
    if( leverage <= 0 )
    {
        Print( "LotSize: invalid AccountLeverage() [", leverage, "]" );
        return(-1);
    }
 
    lot = NormalizeDouble( freemargin * MaximumRisk / leverage / 10.0, 2 );
 
    lot = NormalizeDouble( lot / lot_step, 0 ) * lot_step;
    
    if ( DoubleDown==true ) 
      {
      lot = Lots;
      }
  /*  if ( DoubleDown==true  && (DoubleDownCounterLong==1 || DoubleDownCounterShort==1) ) 
      {
      lot = lot*2;
      }
    if ( DoubleDown==true  && (DoubleDownCounterLong==2 || DoubleDownCounterShort==2)) 
      {
      lot = lot*4;
      DoubleDownCounterLong=0;
      DoubleDownCounterShort=0;
      } 
    if ( DoubleDown==true  && (DoubleDownCounterLong>=3 || DoubleDownCounterShort>=3)) 
      {
      OrderAllowed=false;
      DoubleDownCounterLong=0;
      DoubleDownCounterShort=0;
      }    */
    if ( lot < 0.01 ) lot = 0.01;
    if ( lot > 10 ) lot = 10;
 
    double needmargin = NormalizeDouble( lotsize / leverage * Ask * lot, 2 );
 
    if ( freemargin < needmargin )
    {
        
        Print( "LotSize: We have no money. Need Margin = ", needmargin );
        return(-1);
    }
  // ObjectDelete("Lots");
  // ObjectCreate("Lots"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]+(-20*Point));
  // ObjectSetText("Lots"+DoubleToStr(objtick,0),"Lots: "+DoubleToStr(lot,2),12,"Arial",Yellow);
   DoubleDown=false;
    return(lot);
}

//+---------------------OPENS----------------------------------------+

int OpenBuy()
{
  OrderAllowed=false;
  IsOrderAllowed();
  Lots = LotSize();
   if(OrderAllowed==false)
     {
     return(0);
     } 
   Spread = Ask - Bid;
   
   
   //double LLexit=0;    
   //LLexit = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriodExi,1)];
   // We limit the number of open orders allowed to enter into the market
    for(int i=0;i<=OrdersTotal();i++)  
      {
      if(OrdersTotal() < MaxOpenTrade)
         {
   //---- Open Long Order 
 
          SL=Ask-(StopLoss*Point);
          TP=Ask+(TakeProfit*Point);
          ObjectCreate("Lots"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]+(-20*Point));
          ObjectSetText("Lots"+DoubleToStr(objtick,0),"L: "+DoubleToStr(lot,2),12,"Arial",Yellow);
          //Ordercomment = DoubleToStr(DoubleDownCounterLong,4);
          Ordercomment = DoubleToStr(DoubleDownCounter,0);
          ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,Ordercomment,MagicNumber,0,Blue);
             if(ticket > 0)
               {
               BuyIsOpen = true;
            
               if (Usefilewrite)
                    {
                     handle = FileOpen("MockTurtle.txt",FILE_READ|FILE_WRITE);
                     if(handle!=-1)
                       {
                       FileSeek(handle,0,SEEK_END);
                       FileWrite(handle,"Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice()," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity() );
                       FileWrite(handle,"  ");
           
                       FileFlush(handle);
                       FileClose(handle);
                       }  
                     }  
                if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                 {
                  if(UseAlerts == True)
                     {
                     PlaySound("alert.wav");
                     Alert("Buying Alert --- Buying ",Lots,Symbol(), " @ ",Ask);
                     }
                  }
               }                             
               else
               {
                 Print("Error on the Short Entry: ",GetLastError());
                 PrintErrorValues();
               }
             MaxOpenTrade=1;  
             return (0); 
         }//maxopen 
         else
         {
         MaxOpenTrade=1;
         return(0);
         }        
      }//for loop
}  
  
//+---------------------OPENS---------------------------------------------+

int OpenSell()
{
  OrderAllowed=false;
  IsOrderAllowed();
  Lots = LotSize();
   if(OrderAllowed==false)
     {
     return(0);
     }  
  Spread = Ask - Bid; 
  
  
  
  //double HHexit=0;
  //HHexit = High[Highest(NULL,0,MODE_HIGH,HH_LLAvePeriodExi,BarShift)];
  // We limit the number of open orders allowed to enter into the market
    for(int i=0;i<=OrdersTotal();i++)  
      {
      if(OrdersTotal() < MaxOpenTrade)
         {
   //---- Open Short Order
         ObjectCreate("Lots"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]+(-20*Point));
         ObjectSetText("Lots"+DoubleToStr(objtick,0),"L: "+DoubleToStr(lot,2),12,"Arial",Yellow);
          SL=Bid+(StopLoss*Point);
          TP=Bid-(TakeProfit*Point);
          //Ordercomment = DoubleToStr(DoubleDownCounterShort,4);
          Ordercomment = DoubleToStr(DoubleDownCounter,0);

          ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,Ordercomment,MagicNumber,0,Red);
             if(ticket > 0)
               {
           
               SellIsOpen = true;
                   if (Usefilewrite)
                    {
                     handle = FileOpen("MockTurtle.txt",FILE_READ|FILE_WRITE);
                     if(handle!=-1)
                       {
                       FileSeek(handle,0,SEEK_END);
                       FileWrite(handle,"Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice()," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity() );
                       FileWrite(handle,"  ");
           
                       FileFlush(handle);
                       FileClose(handle);
                       }  
                     }
                if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                 {
                  if(UseAlerts == True)
                     {
                     PlaySound("alert.wav");
                     Alert("Selling Alert --- Selling ",Lots,Symbol(), "@" ,Bid);
                     }
                  }
               }                             
               else
               {
                 Print("Error on the Short Entry: ",GetLastError());
                 PrintErrorValues();
               }
             return (0);
             MaxOpenTrade=1;   
         }//maxopen
         else
         {
         MaxOpenTrade=1;
         return(0);
         }
      }//for loop
}

//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
int PrintErrorValues()
  {
   Print("ErrorValues:Symbol= ", Symbol(),", Ticket=, ",ticket,", Type= ",OrderType(),", Lots= ",Lots, ", Bid= ",Bid, ", Ask= ",Ask,
         ", SlipPage= ", Slippage,", StopLoss= ",SL,", TakeProfit= ", TP);
   return (0);
  }
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
////closes all orders//////////
void EXIT()
{
   Spread = Ask - Bid;
   for( cnt = OrdersTotal()-1; cnt >= 0; cnt-- ) 
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES); 
      if( OrderSymbol() ==  Symbol() && OrderMagicNumber() == MagicNumber ) 
         {
            if( OrderType() ==  OP_BUY )  
               {
               OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Blue);
                  BuyIsOpen = false;
                  if (Usefilewrite)
                  {  
                     if(OrderOpenPrice() + Spread < OrderClosePrice())
                     {   
                        handle = FileOpen("MockTurtle.txt",FILE_READ|FILE_WRITE);
                        if(handle!=-1)
                          {
                          FileSeek(handle,0,SEEK_END);
                          FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice()," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                          FileWrite(handle,"  ");
                    
                          FileFlush(handle);
	                       FileClose(handle);
	                       Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", OrderClosePrice());
	                       }   
                          else
                          {
                          int err;
                          err=GetLastError();
                          Print("error(",err,"): ",ErrorDescription(err));
                          //return(0);                     
                          } 
                    }//if win
                    Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", OrderClosePrice() );     

                     if(OrderOpenPrice() + Spread >= OrderClosePrice())
                     {
                        handle = FileOpen("MockTurtle.txt",FILE_READ|FILE_WRITE);
                        if(handle!=-1)
                          {
                          FileSeek(handle,0,SEEK_END);
                          FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice()," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                          FileWrite(handle,"  ");
                          
                          FileFlush(handle);
	                       FileClose(handle);
	                       Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", OrderClosePrice() );
	                       }   
                          else
                          {
                          int err1;
                          err1=GetLastError();
                          Print("error(",err1,"): ",ErrorDescription(err1));
                          return(0);                     
                          } 
                      }//if lose  
                  }//if use file write  
               }//if type buy
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES); 
            if( OrderSymbol() ==  Symbol() && OrderMagicNumber() == MagicNumber )
            {   
            if( OrderType() ==  OP_SELL )
               {
               OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Red);
               SellIsOpen = false;
               if (Usefilewrite)
               {  
                 if(OrderOpenPrice() - Spread > OrderClosePrice()) 
                  {
                     handle = FileOpen("MockTurtle.txt",FILE_READ|FILE_WRITE);
                     if(handle!=-1)
                       {
                       FileSeek(handle,0,SEEK_END);
                       FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice()," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity() );
                       FileWrite(handle,"  ");
                       
                       FileFlush(handle);
	                    FileClose(handle);
                       Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", OrderClosePrice() );
                       }   
                       else
                       {
                       int err3;
                       err3=GetLastError();
                       Print("error(",err3,"): ",ErrorDescription(err3));
                       //return(0);                     
                       }  
                  }//if win 
                  //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", OrderClosePrice() ); 
              
                  if(OrderOpenPrice() - Spread <= OrderClosePrice())
                     {                
                     handle = FileOpen("MockTurtle.txt",FILE_READ|FILE_WRITE);
                     if(handle!=-1)
                       {
                       FileSeek(handle,0,SEEK_END);
                       FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice()," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                       FileWrite(handle,"  ");
                       FileFlush(handle);
	                    FileClose(handle);
                       Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", OrderClosePrice() );
                       }   
                       else
                       {
                       int err4;
                       err4=GetLastError();
                       Print("error(",err4,"): ",ErrorDescription(err4));
                       return(0);                     
                       }  
                     }//if lose 
                     //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", OrderClosePrice() );   
               }//if use file write
            }//if type sell
            }//if EA order for sell
      }//if EA order for buy
   }//for counter
return(0);
}
//////////end of EXIT all orders/////////////////
////////////jake take function///////////////////
void doubledown()
{
   double OpenOrders = 0;
   for( cnt = 0; cnt < OrdersTotal(); cnt++ ) 
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber ) OpenOrders++;
   }//for loop
   
   if( PreviousOpenOrders>OpenOrders )
   {
  /* ObjectDelete("oo");
   ObjectCreate("oo", OBJ_TEXT, 0, Time[30], High[0]+(60*Point));
   ObjectSetText("oo","oo: "+DoubleToStr(OpenOrders,0),16,"Arial",Yellow);
   ObjectDelete("po");
   ObjectCreate("po", OBJ_TEXT, 0, Time[30], High[0]+(30*Point));
   ObjectSetText("po","po: "+DoubleToStr(PreviousOpenOrders,0),16,"Arial",Yellow);*/
                     
   // retrieving info from trade history
   int i,hstTotal=HistoryTotal();
   for(i=0;i<hstTotal;i++)
     {
     if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)    
     {
      //---- check selection result
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
        {
         Print("Access to history failed with error (",GetLastError(),")");
         break;
        }//if symbol and magic # 
      }//select last order  
      // some work with order
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true)
       {
       if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
         {
         double ii=i;//identifies last closed order's ticket number
         }//if symbol and magic # 
       }//select last order  
     }//for loop
    
     if(OrderSelect(ii,SELECT_BY_POS,MODE_HISTORY)==true)//last closed order on this pair only by this EA code only
     {
       if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
         {   
          //Print("OrderTicket(): ",OrderTicket());
           ObjectCreate("BuyU"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], High[0]+(40*Point));
           ObjectSetText("BuyU"+DoubleToStr(objtick,0),DoubleToStr(OrderTicket(),0),8,"Arial",Yellow);

              if( OrderStopLoss()==OrderClosePrice() )
                 {    
                 if(DoubleDownCounter==3)
                     {
                     DoubleDown=false;
                     DoubleDownCounter=0;
                     PreviousOpenOrders=OpenOrders;
                     return(0);
                     }
                     else
                     {
                     DoubleDown=true;
                     Lots=OrderLots()*2;
                     DoubleDownCounter++;
                  
                     //ObjectDelete("DD");
                   /*  ObjectCreate("DD"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], High[0]+(60*Point));
                     ObjectSetText("DD"+DoubleToStr(objtick,0),"DD: "+DoubleToStr(DoubleDownCounter,0),16,"Arial",Yellow);
                   */  PreviousOpenOrders=OpenOrders;   
                     return(0);
                     }
                  }//last order closed at stop 
                  else
                  {
                  DoubleDown=false;
                  DoubleDownCounter=0;
                  }
                    
             }//if symbol and magic # 
          }//select last histroy order
          
      }//ifprevious>openorders
      PreviousOpenOrders=OpenOrders;



/*for(int i=0;i<OrdersTotal();i++)
   {
   if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true)
      {
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
         {
         if(OrderType()==OP_BUY && OrderStopLoss()==OrderClosePrice() )
            {
            //ObjectDelete("BuyU");
            ObjectCreate("BuyU"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], High[0]+(10*Point));
            ObjectSetText("BuyU"+DoubleToStr(objtick,0),"LDd",8,"Arial",Yellow);                   
            DoubleDown=true;
            Lots=OrderLots()*2;
            //EXIT();
            DoubleDownCounterLong++;
            OpenBuy();
            return(0);
            }
         if(OrderType()==OP_SELL && OrderStopLoss()==OrderClosePrice() )
            {
            //ObjectDelete("SellU");
            ObjectCreate("SellU"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], High[0]+(10*Point));
            ObjectSetText("SellU"+DoubleToStr(objtick,0),"SDd",8,"Arial",Yellow);          

            DoubleDown=true;
            Lots=OrderLots()*2;
            //EXIT();
            DoubleDownCounterShort++;
            OpenSell();
            return(0);
            } 
         }//if symbol and magic
      }//order SELECT_BY_POS
   }//for loop  */         
return(0);
}